import time
import serial
import threading

class openbmip:
    def __init__(self):
        self.cmd_type = 0x00
        self.cmd_code = 0x00
        self.cmd_vers = 0x00
        self.rsp_code = 0x00
        self.cmd_seq = 0x00
        self.dat_len = 0x00
        self.fcstab = [0x0000, 0x1189, 0x2312, 0x329b, 0x4624, 0x57ad, 0x6536, 0x74bf,0x8c48, 0x9dc1, 0xaf5a, 0xbed3, 0xca6c, 0xdbe5, 0xe97e, 0xf8f7,0x1081, 0x0108, 0x3393, 0x221a, 0x56a5, 0x472c, 0x75b7, 0x643e,0x9cc9, 0x8d40, 0xbfdb, 0xae52, 0xdaed, 0xcb64, 0xf9ff, 0xe876,0x2102, 0x308b, 0x0210, 0x1399, 0x6726, 0x76af, 0x4434, 0x55bd,0xad4a, 0xbcc3, 0x8e58, 0x9fd1, 0xeb6e, 0xfae7, 0xc87c, 0xd9f5,0x3183, 0x200a, 0x1291, 0x0318, 0x77a7, 0x662e, 0x54b5, 0x453c,0xbdcb, 0xac42, 0x9ed9, 0x8f50, 0xfbef, 0xea66, 0xd8fd, 0xc974,0x4204, 0x538d, 0x6116, 0x709f, 0x0420, 0x15a9, 0x2732, 0x36bb,0xce4c, 0xdfc5, 0xed5e, 0xfcd7, 0x8868, 0x99e1, 0xab7a, 0xbaf3,0x5285, 0x430c, 0x7197, 0x601e, 0x14a1, 0x0528, 0x37b3, 0x263a,0xdecd, 0xcf44, 0xfddf, 0xec56, 0x98e9, 0x8960, 0xbbfb, 0xaa72,0x6306, 0x728f, 0x4014, 0x519d, 0x2522, 0x34ab, 0x0630, 0x17b9,0xef4e, 0xfec7, 0xcc5c, 0xddd5, 0xa96a, 0xb8e3, 0x8a78, 0x9bf1,0x7387, 0x620e, 0x5095, 0x411c, 0x35a3, 0x242a, 0x16b1, 0x0738,0xffcf, 0xee46, 0xdcdd, 0xcd54, 0xb9eb, 0xa862, 0x9af9, 0x8b70,0x8408, 0x9581, 0xa71a, 0xb693, 0xc22c, 0xd3a5, 0xe13e, 0xf0b7,0x0840, 0x19c9, 0x2b52, 0x3adb, 0x4e64, 0x5fed, 0x6d76, 0x7cff,0x9489, 0x8500, 0xb79b, 0xa612, 0xd2ad, 0xc324, 0xf1bf, 0xe036,0x18c1, 0x0948, 0x3bd3, 0x2a5a, 0x5ee5, 0x4f6c, 0x7df7, 0x6c7e,0xa50a, 0xb483, 0x8618, 0x9791, 0xe32e, 0xf2a7, 0xc03c, 0xd1b5,0x2942, 0x38cb, 0x0a50, 0x1bd9, 0x6f66, 0x7eef, 0x4c74, 0x5dfd,0xb58b, 0xa402, 0x9699, 0x8710, 0xf3af, 0xe226, 0xd0bd, 0xc134,0x39c3, 0x284a, 0x1ad1, 0x0b58, 0x7fe7, 0x6e6e, 0x5cf5, 0x4d7c,0xc60c, 0xd785, 0xe51e, 0xf497, 0x8028, 0x91a1, 0xa33a, 0xb2b3,0x4a44, 0x5bcd, 0x6956, 0x78df, 0x0c60, 0x1de9, 0x2f72, 0x3efb,0xd68d, 0xc704, 0xf59f, 0xe416, 0x90a9, 0x8120, 0xb3bb, 0xa232,0x5ac5, 0x4b4c, 0x79d7, 0x685e, 0x1ce1, 0x0d68, 0x3ff3, 0x2e7a,0xe70e, 0xf687, 0xc41c, 0xd595, 0xa12a, 0xb0a3, 0x8238, 0x93b1,0x6b46, 0x7acf, 0x4854, 0x59dd, 0x2d62, 0x3ceb, 0x0e70, 0x1ff9,0xf78f, 0xe606, 0xd49d, 0xc514, 0xb1ab, 0xa022, 0x92b9, 0x8330,0x7bc7, 0x6a4e, 0x58d5, 0x495c, 0x3de3, 0x2c6a, 0x1ef1, 0x0f78]
        self.cmd = ["GFAULTSTATUS","GPAPOWER","GPRODUCTID","GHEARTBEAT","GLOSCILLATOR"
                ,"GBANDSEL","SBANDSEL","SLOSCILLATOR","RSTATUSLATCH","SENDFILE"
                ,"STATUSKERMITFILE","RECEIVEFILE","GSOFTWAREVER","GCALIBFILE","SCALIBFILE"
                ,"PREP_UPGRADE","BUC_RST","GLFAULTSTATUS","GPOWERAMP","SPOWERAMP","UPDATESIM"]
    def update(self, rbuf):
        # trim start
        tbuf0 = rbuf
        ridx = 0
        for i in range(len(tbuf0)):
            if hex(ord(tbuf0[i])) ==  hex(0xc0) : 
                ridx = i + 1
            else :
                break;
        # tbuf0[ridx:len(rbuf)]
        tbuf0 = tbuf0[ridx:len(rbuf)]
        # print(ridx)
        # print " ".join(hex(ord(n)) for n in tbuf0)
        
        rcnt = 0
        for i in range(len(tbuf0),0,-1):
            print(hex(ord(tbuf0[i-1])))
            if hex(ord(tbuf0[i-1])) ==  hex(0xc0) : 
                rcnt = rcnt + 1
            else :
                break;
        tbuf0 = tbuf0[0:(len(tbuf0)-rcnt)]
        # print(rcnt)
        # print " ".join(hex(ord(n)) for n in tbuf0)
        buf = tbuf0
        # trim end
        
        idx = 0
        self.cmd_type = (int(ord(buf[idx]))>>7)&0x01
        self.cmd_code = int(ord(buf[idx]))&0x7F
        self.cmd_vers = int(ord(buf[idx+1]))&0x07
        self.rsp_code = (int(ord(buf[idx+1]))>>3)&0x1F
        self.cmd_seq = (int(ord(buf[idx+2]))<<8)+int(ord(buf[idx+3]))
        self.dat_len = (int(ord(buf[idx+4]))<<8)+int(ord(buf[idx+5]))
        try:
            self.fcs = (int(ord(buf[len(tbuf0)-2]))<<8)+int(ord(buf[len(tbuf0)-1]));
        except:
            self.fcs = 0
            print("error - (int(ord(buf[idx+6+self.dat_len]))<<8)+int(ord(buf[idx+7+self.dat_len]))")
        
        # self.cmd_type = (hex(ord(buf[0]))>>7)&0x01
        # self.cmd_code = hex(ord(buf[0]))&0x7F
        # self.cmd_vers = hex(ord(buf[1]))&0x07
        # self.rsp_code = (hex(ord(buf[1]))>>3)&0x1F
        # self.cmd_seq = (hex(ord(buf[2]))<<8)+hex(ord(buf[3]))
        # self.dat_len = (hex(ord(buf[4]))<<8)+hex(ord(buf[5]))
    def printf(self): 
        print("cmd type \t:{}".format(hex(self.cmd_type)))
        print("cmd code \t:{}({})".format(hex(self.cmd_code), self.cmd[self.cmd_code]))
        print("cmd vers \t:{}".format(hex(self.cmd_vers)))
        print("rsp code \t:{}".format(hex(self.rsp_code)))
        print("cmd seq  \t:{}".format(hex(self.cmd_seq)))
        print("length \t\t:{}".format(self.dat_len))
        print("fcs \t\t:{}".format(hex(self.fcs)))
        
        self.pppfcs(self.cmd_type, self.cmd_code, self.rsp_code, self.cmd_vers, self.cmd_seq, self.dat_len, self.fcs)
        
    def pppfcs(self, typ, cmd, rsp, vers, seq, _len, fcs): 
        debug = False
        if debug : print("run - pppfcs ---------------------")
        if debug : print("1. resorting")
        packet = []
        packet.append((0xff&(typ<<7))+ (cmd&0x7f))
        packet.append((0xff&(rsp<<3)) + (vers&0x07))
        packet.append(0xff&(seq>>8))
        packet.append(0xff&(seq))
        packet.append(0xff&(_len>>8))
        packet.append(0xff&(_len))
        if debug : print " ".join(hex(i) for i in packet)

        for i in range(len(packet)):
            if packet[i] == 0xc0 :
                packet[i] = 0xdb
                packet.insert(i+1,0xdc)
            elif packet[i] == 0xdb :
                packet.insert(i+1,0xdd)
        if debug : print("2. trim")
        if debug : print " ".join(hex(i) for i in packet)        

        fcs = 0xffff
        for i in range(len(packet)):
            fidx = (fcs ^ packet[i]) & 0xff
            fcs = (fcs >> 8) ^ self.fcstab[fidx]
            print("{} - {} - {}({}) - {} - {}".format(hex(packet[i]), hex(0xffff^fcs), hex(fidx), int(fidx), hex(fcs >> 8), hex(self.fcstab[fidx])))
        if debug : print("3. fcs tabling")
        if debug : print("fcs\t\t:{}".format( hex(0xffff^fcs) ))
        if debug : print("4. result ")
        if debug : print("compare\t:{}=={} >> {}".format( hex(self.fcs), hex(0xffff^fcs),  hex(self.fcs)==hex(0xffff^fcs)))
        print("compare\t:{}=={} >> {}".format( hex(self.fcs), hex(0xffff^fcs),  hex(self.fcs)==hex(0xffff^fcs)))
