#-*- coding:utf-8 -*-
import time
from enum import Enum
from threading import Thread

class DataType(Enum):
        Integer = 1
        UnsignedInteger = 2
        Float = 4
        String = 9

class Data:
    def __init__(self,name,dtype,tag,value):
        self.Name = name
        self.Tag = tag
        self.Type = dtype
        self.Value = value
        self.OldValue = value
        self.CheckCnt = 0
    def Set(self,value):
        # print "%s ->%s (%d)"%(self.OldValue,value, self.CheckCnt)
        if value != self.Value:
            # if self.CheckCnt > 0 :
                # print "self.checkcnt > 0 Event "
            self.OldValue = value
            self.Value = value
            self.CheckCnt = 20
    def ToInt(self):
        if DataType.Integer == self.Type :
            return int(self.Value)
    def ToFloat(self):
        if DataType.Float == self.Type :
            return float(self.Value)
    def IsChanged(self):
        return self.CheckCnt > 0
    def Check(self):
        if self.CheckCnt > 0:
            self.CheckCnt -= 1
    def GetStatus(self):
        reval = 0
        if self.IsChanged():
            reval += 0x00000001
        return reval
        
class DataList:
    def __init__(self):
        self.List = []
        self.MatchingList = []
        p = Thread(target=self.Worker)
        p.start()
    def Push(self,d): self.List.append(d)
    def Pop(self): return self.List.pop()
    def Get(self,idx):
        if len(self.List) >= idx:
            self.ReturnUnknown() 
        return self.List[idx]
    def GetWithTokenObj(self,name):
        for i in self.List: 
            if i.Name == name or i.Tag == name:
                return i
    def GetWithToken(self,name):
        tmp = 'Unknown'
        for i in self.List: 
            if i.Name == name or i.Tag == name:
                tmp = i.Value
                break; 
        return tmp
    def Find(self,name):
        for i in self.List: 
            if i.Name == name:
                return i
        return self.ReturnUnknown()
    def Set(self,name, value):
        tmp = str(value)
        for i in self.List: 
            if i.Name == name or i.Tag == name:
                # i.Value = tmp
                if len(tmp) == 0 : 
                    if(i.Type == DataType.String) : tmp = "Unknown"
                    else : tmp = '0'
                i.Set(tmp)
                break; 
    def SetWithTag(self,dat):
        if(len(dat)<3): return 0
        tag = dat[0:2]
        val = dat[2:len(dat)]
        self.Set(tag,val)
        return 1
    def ReturnUnknown(self):
        return Data("Unknown","Uk",DataType.String,"")  
    def SetMatchString(self,arr):
        self.MatchingList = arr
    def GetMatchString(self,idx):
        if len(self.List) >= idx:
            return "Unknown"
        return self.MatchingList[idx]
    def PrintAll(self):
        for i in self.List: 
            # usage("{}-{}-{}".format(i.Name,i.Value,i.Tag))
            print("%-20s%-20s%-20s"%(i.Name,i.Value,i.Tag))
    def Worker(self):
        while True:
            time.sleep(0.1)
            for i in self.List: 
                i.Check()
                
            
            
            
            
            
            
            
            