#-*- coding:utf-8 -*-
import json
import os
import datetime
from time import sleep
from Util import *
from Project import *

class System:
    
    #######################################################################################
    # Configuration
    @staticmethod
    def LoadConf():
        conf=None
        with open('/home/pi/acu/config.json') as json_file:
            conf = json.load(json_file)      
        return conf
    @staticmethod
    def SaveConf():
        from Project import pj 
        with open('/home/pi/acu/config.json', "w") as json_file:
            json.dump(pj.Conf, json_file)
     
    #######################################################################################       
    #Log
    @staticmethod
    def Log(func, msg):
        from Project import pj 
        # Trim the function name. 
        name = func
        if len(func)>15: name=func[0:14]
        tmp = msg
        # LogOption - Stript
        if pj.Conf['Log']['Option']['Data']['Strip']==1:
            tmp = tmp.strip()
        # LogOption - Cut
        if pj.Conf['Log']['Option']['Data']['Cut']==1:
            cutLen = pj.Conf['Log']['Option']['Data']['CutLen']
            if len(msg)>cutLen: 
                tmp = msg[0:cutLen]
                tmp = tmp+"..."
        print("%s %-15s %s"%(Util.GetSystime(),name,tmp))
    
    #######################################################################################
    # Creat javascript for webSocket
    @staticmethod
    def CreateWebsocketJs():
        f = open('/home/pi/acu/www/assets/js/kns-acu.js','w')
        f.write("var webSocket; ")
        f.write("function ConnectWebSocket(){webSocket=new WebSocket('ws://"+"{}".format(Util.GetIpAddress())+":52100');} ")
        f.close()

    #######################################################################################
    # PCU ACK/TmErr 
    TmErr = 0
    AckOk = 0
    AckTime = 0
    AckTimeSum = 0
    AckStatus = False
    AckMessage = ""
    @staticmethod
    def OccurredTmErr(): System.TmErr=System.TmErr+1
    @staticmethod
    def AckOK(): System.AckOk=System.AckOk+1

def PcuAckChecker(arg):
    from Project import pj 
    AckStatus=False
    AckMessage=""
    tid = Util.GetSystime()
    # print("{}-tm:{},idx:{}".format(__name__,arg[0],arg[1]))
    for i in range(arg[0]):
        if arg[1]==Util.CrcCrt:
            break 
        # print("Checked CRC - {}/{}".format(arg[1], Util.CrcCrt))
        sleep(0.010) 
    if arg[0]==i: System.OccurredTmErr()
    else: 
        System.AckOK()
        System.AckTimeSum=System.AckTimeSum+i
        System.AckTime=i
        AckStatus=True
        
    if pj.Conf['Log']['Filter']['PcuCommunication']['CRC']==1: 
        System.Log(__name__, "[PCU CRC] Done:{} / Error:{}\t\tTime:{:.2f}ms / AVG Time:{:.2f}ms\t   ".format(System.AckOk, System.TmErr, System.AckTime, (System.AckTimeSum/System.AckOk)))