#-*- coding:utf-8 -*-
import os
import datetime


class Util:
    @staticmethod
    def StringReplace(fpath, idx, line): os.system("sudo sed -i \"{}s/.*/{}/g\" {}".format(str(idx),line,fpath))
    @staticmethod
    def ReplaceIPAddress(dat): Util.StringReplace("/etc/network/interfaces",14,'address '+dat)
    @staticmethod
    def ReplaceNetmask(dat): Util.StringReplace("/etc/network/interfaces",15,'netmask '+dat) 
    @staticmethod
    def ReplaceGateway(dat): Util.StringReplace("/etc/network/interfaces",16,'gateway '+dat)
    @staticmethod
    def GetIpAddress(): 
        f = open('/etc/network/interfaces','r')
        for i, line in enumerate(f):
            if i == 13: o_ip = line.strip().split()[1]
        f.close()
        return o_ip    
    @staticmethod
    def UpdateEth0WithLog(ip,net,gw):
        f = open('/etc/network/interfaces','r')
        for i, line in enumerate(f):
            if i == 13: o_ip = line.strip().split()[1]
            if i == 14: o_net = line.strip().split()[1]
            if i == 15: o_gw = line.strip().split()[1]
        f.close()
        Util.ReplaceIPAddress(ip)
        Util.ReplaceNetmask(net)
        Util.ReplaceGateway(gw)
        f = open('/etc/network/interfaces','r')
        for i, line in enumerate(f):
            if i == 13: n_ip = line.strip().split()[1]
            if i == 14: n_net = line.strip().split()[1]
            if i == 15: n_gw = line.strip().split()[1]
        f.close()
        print("{} -> {}".format(o_ip, n_ip)) 
        print("{} -> {}".format(o_net, n_net))
        print("{} -> {}".format(o_gw, n_gw))
    @staticmethod
    def GetTemperature(): 
        tmp = os.popen("vcgencmd measure_temp").read()
        tmp1 = tmp.split('=')
        tmp2 = tmp1[1].split('\'')
        return float(tmp2[0])
    @staticmethod
    def GetSystime(): return str(datetime.datetime.now())[0:22]
    @staticmethod
    def GetUTC(): return datetime.datetime.utcnow().strftime('%H%M%S.%f')[:-3]
        
    # ----------------------------------------------------------------------------------------------
    # CRC for PCU Protocol
    CrcIdx = 0
    CrcCrt = 0
    CrcMessage=""
    CrcStatus=False
    @staticmethod
    def AppendCRC(dat): 
        Util.CrcIdx = Util.CrcIdx  + 1;
        Util.CrcIdx = 1 if Util.CrcIdx > 9 else Util.CrcIdx
        text = dat;
        text = text.replace('\t', '').replace('\n', '').replace('\r', '')
        text = text+','
        text = text+str(Util.CrcIdx)
        crc = 0;
        for i in text :
            crc = 0xffff&(crc >> 8) | 0xffff&(crc << 8);
            crc ^= ord(i);
            crc ^= 0xffff&((crc & 0xff) >> 4);
            crc ^= 0xffff&(crc << 12);
            crc ^= 0xffff&((crc & 0x00ff) << 5);
        return "%s*%04X\r\n"%(text,crc)    
    @staticmethod
    def CheckCrcForPCU(dat): 
        # if dat[0:2]!="$KB": CrcStatus=False
        Util.CrcStatus=False
        # print("1, {}".format(Util.CrcStatus))
        # Exception - hhwang, 21111116
        if len(dat)<6: return False;
        
        text = dat;
        text = text.replace('\t', '').replace('\n', '').replace('\r', '')
        if text[len(text)-5] == '*':
            trimmed_text = text[0:len(text)-5]
            crc_text = text[len(text)-4:len(text)]
            crc_text_converted = int(crc_text, base=16)
            crc = 0;
            for i in trimmed_text :
                crc = 0xffff&(crc >> 8) | 0xffff&(crc << 8);
                crc ^= ord(i);
                crc ^= 0xffff&((crc & 0xff) >> 4);
                crc ^= 0xffff&(crc << 12);
                crc ^= 0xffff&((crc & 0x00ff) << 5);
            if crc == crc_text_converted: 
                if dat[0:3]!="$KB":
                    # print(dat[0:3])
                    # print("2, {}".format(Util.CrcStatus))
                    Util.CrcCrt=int(text[len(text)-6])
                    Util.CrcMessage=dat
                    Util.CrcStatus=True
                return True
            else: 
                return False
        return False
    @staticmethod
    def CheckCRC(dat): 
        # Exception - hhwang, 21111116
        if len(dat)<6: return False;
        
        text = dat;
        text = text.replace('\t', '').replace('\n', '').replace('\r', '')
        if text[len(text)-5] == '*':
            trimmed_text = text[0:len(text)-5]
            crc_text = text[len(text)-4:len(text)]
            crc_text_converted = int(crc_text, base=16)
            crc = 0;
            for i in trimmed_text :
                crc = 0xffff&(crc >> 8) | 0xffff&(crc << 8);
                crc ^= ord(i);
                crc ^= 0xffff&((crc & 0xff) >> 4);
                crc ^= 0xffff&(crc << 12);
                crc ^= 0xffff&((crc & 0x00ff) << 5);
            if crc == crc_text_converted: 
                return True
            else: 
                return False
        return False
    @staticmethod
    def Dump(dat): 
        # Exception - hhwang, 21111116
        if len(dat)<6: return False;
        
        text = dat;
        text = text.replace('\t', '').replace('\n', '').replace('\r', '')
        if text[len(text)-5] == '*':
            trimmed_text = text[0:len(text)-5]
            crc_text = text[len(text)-4:len(text)]
            crc_text_converted = int(crc_text, base=16)
            crc = 0;
            for i in trimmed_text :
                crc = 0xffff&(crc >> 8) | 0xffff&(crc << 8);
                crc ^= ord(i);
                crc ^= 0xffff&((crc & 0xff) >> 4);
                crc ^= 0xffff&(crc << 12);
                crc ^= 0xffff&((crc & 0x00ff) << 5);
            if crc == crc_text_converted: 
                return True
            else: 
                return False
        return False
        
