import os
import sys
import time
from datetime import datetime

def delete_old_files(path_target, days_elapsed):
    """path_target, days_elapsed (day) """
    for f in os.listdir(path_target): 
        f = os.path.join(path_target, f)
        if os.path.isfile(f): 
            timestamp_now = 0
            if sys.version_info[0] < 3 or sys.version_info[1] < 4:
                timestamp_now = time.mktime(datetime.now().timetuple())
            else:
                timestamp_now = datetime.now().timestamp() 
            is_old = os.stat(f).st_mtime < timestamp_now - (days_elapsed * 24 * 60 * 60)
            if is_old: 
                try:
                    os.remove(f) 
                    print(f, 'is deleted') 
                except OSError: 
                    print(f, 'can not delete') 
                    
def delete_all_files(path_target):
    """path_target, days_elapsed (day) """
    for f in os.listdir(path_target): 
        f = os.path.join(path_target, f)
        if os.path.isfile(f): os.remove(f) 