/*
	xgraph.js
	
	KNS Inc.
	Satellite R&D Lab
	Creator - Wang Hyunho
	Device - Antenna Control Unit
*/


//-----------------------------------------------------------------------------------------------------------
//Processing chart data.

	window.onload = function() {
		/* Initialize */
		//Initialize GUI
		InitializeGUI();
		//Check the antenna status.
		SendEventForDemo(10,1,[,]);
		//Stop running if reload the page.
		StopXGraph({id:0x0A02, list:GetSelectedChartItems(), dt:GetDT()});
		
		/* setIntervals */
		//Checking GUI.
		setInterval(function() { CheckChartData();},1000)
		setInterval(function() { CheckGUI(); },200)
		//Controlling stream speed.
		// setInterval(function() { if(!handle_flag&&chartstat&&update_step==12) UpdateChart(); },1);
		// setInterval(function() { if(!handle_flag&&chartstat&&update_step==11) UpdateChart(); },5);
		// setInterval(function() { if(!handle_flag&&chartstat&&update_step==10) UpdateChart(); },10);
		// setInterval(function() { if(!handle_flag&&chartstat&&update_step==9) UpdateChart(); },20);
		// setInterval(function() { if(!handle_flag&&chartstat&&update_step==8) UpdateChart(); },30);
		// setInterval(function() { if(!handle_flag&&chartstat&&update_step==7) UpdateChart(); },40);
		// setInterval(function() { if(!handle_flag&&chartstat&&update_step==6) UpdateChart(); },50);
		// setInterval(function() { if(!handle_flag&&chartstat&&update_step==5) UpdateChart(); },60);
		// setInterval(function() { if(!handle_flag&&chartstat&&update_step==4) UpdateChart(); },70);
		// setInterval(function() { if(!handle_flag&&chartstat&&update_step==3) UpdateChart(); },80);
		// setInterval(function() { if(!handle_flag&&chartstat&&update_step==2) UpdateChart(); },90);
		// setInterval(function() { if(!handle_flag&&chartstat&&update_step==1) UpdateChart(); },100);
		
		setInterval(function() { if(!handle_flag&&chartstat&&update_step==12) UpdateChart(); },1);
		setInterval(function() { if(!handle_flag&&chartstat&&update_step==11) UpdateChart(); },1);
		setInterval(function() { if(!handle_flag&&chartstat&&update_step==10) UpdateChart(); },2);
		setInterval(function() { if(!handle_flag&&chartstat&&update_step==9) UpdateChart(); },2);
		setInterval(function() { if(!handle_flag&&chartstat&&update_step==8) UpdateChart(); },3);
		setInterval(function() { if(!handle_flag&&chartstat&&update_step==7) UpdateChart(); },3);
		setInterval(function() { if(!handle_flag&&chartstat&&update_step==6) UpdateChart(); },4);
		setInterval(function() { if(!handle_flag&&chartstat&&update_step==5) UpdateChart(); },5);
		setInterval(function() { if(!handle_flag&&chartstat&&update_step==4) UpdateChart(); },10);
		setInterval(function() { if(!handle_flag&&chartstat&&update_step==3) UpdateChart(); },15);
		setInterval(function() { if(!handle_flag&&chartstat&&update_step==2) UpdateChart(); },30);
		setInterval(function() { if(!handle_flag&&chartstat&&update_step==1) UpdateChart(); },100);
	};
	

	function InitializeGUI(){
		//Update title of page.
		//document.getElementById('title').innerHTML = 'xGraph Demo v'+ xgraph.GetVersion() + " <font style='font-size: 20px;color: darkgray;'>(Updated: "+xgraph.GetVersionDT()+")</font>"; 
		//Button events
		$('.image').find(".export").click(function(){ downloadObjectAsJson(tmpImage) } );
		//Configurate line buttons.
		for(i=0;i<100;i++)document.getElementById('item-container'+i).childNodes[0].childNodes[0].innerHTML = "<p class='text'><font class='number'>"+pad(i,2)+"</font></p>";
		//Initialize charts.
		xgraph.DrawStripChart();
		xgraph.DrawImageChart();
		xgraph.chart.image.handle.updateSeries(xgraph.dat2.Series);
		
	}
	
	function CheckGUI(){
		/* Chart options 1 - Select sample numbers  */
		if(document.getElementById('opt_snt1').checked) uStripSampleNumber =100;
		else if(document.getElementById('opt_snt2').checked) uStripSampleNumber =200;
		else if(document.getElementById('opt_snt3').checked) uStripSampleNumber =300;
		else if(document.getElementById('opt_snt4').checked) uStripSampleNumber =500;
		if(document.getElementById('opt_int1').checked) uImageSampleNumber =500;
		else if(document.getElementById('opt_int2').checked) uImageSampleNumber =1000;
		else if(document.getElementById('opt_int3').checked) uImageSampleNumber =5000;
		else if(document.getElementById('opt_int4').checked) uImageSampleNumber =10000;
		else if(document.getElementById('opt_int5').checked) uImageSampleNumber =50000;
		/* Chart options 2 - Control GUI  */
		if(document.getElementById('sw_image').checked){ if(document.getElementById('chart-image').hidden) document.getElementById('chart-image').hidden = false;
		} else{ if(!document.getElementById('chart-image').hidden) document.getElementById('chart-image').hidden = true; }
		if(document.getElementById('sw_strip').checked) { if(document.getElementById('chart-strip').hidden) document.getElementById('chart-strip').hidden= false;
		} else { if(!document.getElementById('chart-strip').hidden) document.getElementById('chart-strip').hidden = true; }
		if(document.getElementById('sw_option').checked) { if(document.getElementById('option').hidden) document.getElementById('option').hidden= false;
		} else { if(!document.getElementById('option').hidden) document.getElementById('option').hidden = true; }
		if(document.getElementById('sw_sel').checked) { if(document.getElementById('items').hidden) document.getElementById('items').hidden= false;
		} else { if(!document.getElementById('items').hidden) document.getElementById('items').hidden = true; }
		/* Start & Stop button   */ 
		if(chartstat){
			if(!_('btnStart').disabled) _('btnStart').disabled = true;
			if(_('btnStop').disabled) _('btnStop').disabled = false;
		
		}else {
			if(_('btnStart').disabled) _('btnStart').disabled = false;
			if(!_('btnStop').disabled) _('btnStop').disabled = true;
			
		}
		/* Import / Export */
		if(chartstat)$('.imgchart').find('.import').attr('disabled',true)
		else $('.imgchart').find('.import').attr('disabled',false)
	
		var list = GetSelectedChartItems();
		var tmp ="Sample[Strip: "+uStripSampleNumber+"/Image: "+uImageSampleNumber+"]"
		if(list.length>0) tmp+=", Selected Items: "+list
		else tmp+=", Selected Items: None"
		$(".option").find('.status').html(tmp);
		
	}
	
	var handle_flag = false;
	var update_step = 1;
	var handle_for_update;
	var overflow = 0;
	var proc_num = 0;
	var dynamicInterval=100;
	function UpdateChart()	
	{
		handle_flag =true;
		
		if(cStrip.length<=0){
			handle_flag=false;
			return;
		}
	
		if(chart_trig){
			chart_trig = false;
			old_idx = -1;
			
			xgraph.dat1 = { Series:[]};
			xgraph.dat2 = { Series:[]};
			
			var tmp = GetSelectedChartItems();
			if(tmp.length>0){
				for(i=0;i<tmp.length;i++){;
					xgraph.dat1.Series.push({name:'Data '+tmp[i],data:[]});
					xgraph.dat2.Series.push({name:'Data '+tmp[i],data:[]});
				}
			}else{
				for(i=0;i<chart_dat_num;i++){;
					xgraph.dat1.Series.push({name:'? ('+i+')', data:[]});
					xgraph.dat2.Series.push({name:'? ('+i+')', data:[]});
				}
			}
			cStrip = [];
			uStrip = [];
			uStripIdx = 0;
			uImage = [];
		}else
		{
		
		}
		
		if(cStrip.length>10){
		
			var obj = cStrip.shift();
			var nums = (cStrip[cStrip.length-1].Index-cStrip[0].Index);
			
			if(nums<20) update_step = 1;
			else if((cStrip[cStrip.length-1].Index-cStrip[0].Index)<50) update_step = 2;
			else if((cStrip[cStrip.length-1].Index-cStrip[0].Index)<100) update_step = 3;
			else if((cStrip[cStrip.length-1].Index-cStrip[0].Index)<200) update_step = 4;
			else if((cStrip[cStrip.length-1].Index-cStrip[0].Index)<300) update_step = 5;
			else if((cStrip[cStrip.length-1].Index-cStrip[0].Index)<400) update_step = 6;
			else if((cStrip[cStrip.length-1].Index-cStrip[0].Index)<500) update_step = 7;
			else if((cStrip[cStrip.length-1].Index-cStrip[0].Index)<600) update_step = 8;
			else if((cStrip[cStrip.length-1].Index-cStrip[0].Index)<700) update_step = 9;
			else if((cStrip[cStrip.length-1].Index-cStrip[0].Index)<800) update_step = 10;
			else if((cStrip[cStrip.length-1].Index-cStrip[0].Index)<900) update_step = 11;
			else if((cStrip[cStrip.length-1].Index-cStrip[0].Index)<1000) update_step = 12;

			
			if((cStrip[cStrip.length-1].Index-cStrip[0].Index)>1300) obj = cStrip.shift(), overflow++;
			if((cStrip[cStrip.length-1].Index-cStrip[0].Index)>1600) obj = cStrip.shift(), overflow++;
			if((cStrip[cStrip.length-1].Index-cStrip[0].Index)>2000) obj = cStrip.shift(), overflow++;
			
			//console.log('['+update_step+'] '+(cStrip[cStrip.length-1].Index-cStrip[0].Index) + " / "+ overflow);
			proc_num++;
			if(overflow%500==0&&overflow>1){
				_noti(2,"[overflow] dropped data for processing."+(overflow/proc_num*100).toFixed(1)+"% ( DT is too little! )");
				overflow = 0,proc_num =0;
			};
			
			UpdateChartData(obj);				
		}
		
		handle_flag =false;
	}

	
	var uStrip = [];
	var uImage = [];
	var tmpImage = [];
	var uStripSampleNumber =200;
	var uImageSampleNumber =1000;
	var uStripIdx = 0;
	var uImageDT = "0000-00-00~0000-00-00";
	function UpdateChartData(dat)
	{
		var obj = {x:0, y:0};
		var obj1 = {x:0, y:0};
		var obj2 = {x:0, y:0};
		
		try
		{
			if(uStrip.length>0){
				if(uStrip[uStrip.length-1].Index >= dat.Index) return;
			}
			
			//----------------------------------------------------------------------------------------------------------------------
			//uStript Chart (Realtime) 
			uStripIdx++;
		
			uImage.push(dat);
			uStrip.push(dat);
			while(uStrip.length>uStripSampleNumber) {uStrip.shift();}
			var tmp = ""
			tmp = "Datetime ("+uStrip[0].Updated + "~" + uStrip[uStrip.length-1].Updated+")"+" / "
			tmp += "Sample ("+uStrip.length+"/"+uStripSampleNumber+")"+" / "
			// tmp += "Statcked ("+(cStrip[cStrip.length-1].Index-cStrip[0].Index)+")"
			tmp += "Delay ("+((cStrip[cStrip.length-1].Index-cStrip[0].Index)/50).toFixed(2)+"s)"
			//document.getElementById('time1').innerHTML = tmp;
			$(".strip").find('.status').html(tmp);
			
			for(i=0;i<xgraph.dat1.Series.length;i++)
			{
				xgraph.dat1.Series[i].data.push({x:uStripIdx, y:dat.Point[i]});
				
				while(xgraph.dat1.Series[i].data.length>uStripSampleNumber) {xgraph.dat1.Series[i].data.shift()}
			}
			xgraph.chart.strip.handle.updateSeries(xgraph.dat1.Series);

			//----------------------------------------------------------------------------------------------------------------------
			// uImage Chart (Static)
			var txt = "Image Chart ["+uImage.length+"/"+uImageSampleNumber+"] ";
			if(uImage.length>=uImageSampleNumber)
			{
				UpdateImageChart(uImage)
				tmpImage = uImage;
				uImage=[];
			}
			//document.getElementById('time2').innerHTML = txt + uImageDT;
			tmp = "Datetime ("+uImageDT+")"+" / "
			tmp += "Sample ("+uImage.length+"/"+uImageSampleNumber+")"
			//document.getElementById('time1').innerHTML = tmp;
			$(".image").find('.status').html(tmp);
		}
		catch(e){
			console.log("[Error 012] UpdateChartData");
		}
	}
	
	function UpdateImageChart(obj){
		for(i=0;i<xgraph.dat2.Series.length;i++) 
		{
			xgraph.dat2.Series[i].data = [];
		}
		
		for(i=0;i<obj.length;i++){
			for(j=0;j<xgraph.dat2.Series.length;j++)
			{
				xgraph.dat2.Series[j].data.push({x:i, y:obj[i].Point[j]});
			}
		}
		
		uImageDT=obj[0].Updated + "~" + obj[obj.length-1].Updated;
		
		xgraph.chart.image.handle.updateSeries(xgraph.dat2.Series);
	}
	
	var cStrip = [];
	var old_idx = -1;
	var arrStrip = new Array();
	var chart_oper_cnt	= 0;
	var chart_idx	= 0;
	var chartstat = false;
	var chart_trig = false;
	var chart_dat_num = 0;
	function CheckChartData()
	{
		$.ajax({
			type: "POST",
			async: false,
			url:        "/feed/xgraph.json",
			dataType:   "json", 
			success:    function(data){
			
			
				chart_dat_num = data[0].Point.length;
				/* Check xgraph.json */
				//console.log(data[data.length-1].Index + ", "+ chartstat );
				if(chart_idx != data[data.length-1].Index){
					if(!chartstat){
						chart_oper_cnt++;
						if(chart_oper_cnt > 1){ 
							chartstat = true;
							chart_trig=true;
							_noti(1, "Started,Actived 'Stop'.");
							cStrip = [];
						}
					}
					chart_oper_cnt=3;
				}else{
					chart_oper_cnt--;
					chart_oper_cnt=chart_oper_cnt<0?0:chart_oper_cnt;
					if(chart_oper_cnt==0){
						if(chartstat){
							chartstat = false;
							_noti(1, "Stoped, Ready for 'Start'.");
						}
					}
				}
				chart_idx=data[data.length-1].Index;
				
				if(cStrip.length>0){
					var stat = ""
					stat += "Use:"+chartstat + "/ ";
					stat += "Step:"+update_step + "/ ";
					//stat += "Step:"+chart_oper_cnt + "/ ";
					stat += "SIdx:"+cStrip[0].Index + "/ ";
					stat += "EIdx:"+cStrip[cStrip.length-1].Index + "/ ";
					stat += "Size:"+(cStrip[cStrip.length-1].Index-cStrip[0].Index) + "/ ";
					console.log(stat)
					//console.log(update_step + "/ "+ chartstat + "/ "+ chart_oper_cnt + ", "+ cStrip[0].Index + "/ "+ cStrip[cStrip.length-1].Index + "/ "+ (cStrip[cStrip.length-1].Index-cStrip[0].Index) + "/ ");
				}
				else console.log(update_step + "/ "+ chartstat + "/ "+ chart_oper_cnt + ", ");
				
				if(chartstat){
					var sta = 0;
					//Check Chart Index
					for(i=0;i<data.length;i++){
						if(data[i].Index>old_idx){
							old_idx = data[i].Index;
							sta = i;
							break;
						}
					}
					
					for(i=sta;i<data.length;i++){
						cStrip.push(data[i]);
						old_idx = data[i].Index;
					}
					//console.log("Update => "+cStrip[0].Index + "-" + cStrip[cStrip.length-1].Index);
				}
			}
		});
	}
	
	/* Util */
	var graph_listflag = [];
	
	function pad(n, width) {
	  n = n + '';
	  return n.length >= width ? n : new Array(width - n.length + 1).join('0') + n;
	}
	
	function GetSelectedChartItems()
	{
		var val = new Array();
		for(i=0;i<graph_listflag.length;i++){
			if(graph_listflag[i]) {
				val.push(i);
			}
		}
		
		return val;
	}
	
	function SelDataType(obj)
	{
		if(chartstat){
			alert('Running Now...');
			return;
		}
		
		var id = obj.id;
		var num = parseInt(obj.id.split('item-container')[1]);
		graph_listflag[num]=!graph_listflag[num];
		
		var tmp = obj.childNodes[0];
		if(graph_listflag[num]) tmp.style.background ='#f3bb45';
		else tmp.style.background ='white';
	}
	
	function UpdateImportPoint(obj)
	{
		graph_listflag = []
		for(var i=0;i<obj[obj.length-1];i++) graph_listflag[i] = false;
		for(var i=0;i<obj.length;i++) graph_listflag[obj[i]] = true;
	
	}
	
	function GetDT()
	{
		return document.getElementById('inpDT').value / 1000;
	}
	
	function SideButtonToggleEvent(id){
		if(document.getElementById(id).checked) document.getElementById(id).checked = false;
		else document.getElementById(id).checked = true;
	}
	
	function GetSelectedChartItems()
	{
		var val = new Array();
		for(i=0;i<graph_listflag.length;i++){
			if(graph_listflag[i]) {
				val.push(i);
			}
		}
		return val;
	}
	
	function StartXGraph(obj)
	{
		console.log(JSON.stringify(obj));
		
		if(obj.list.length<=0){
			alert('No Parameter ! ');
			return;
		}
		
		document.getElementById('sw_strip').checked = true;
		$('.import-info').html("")
		$('.import-modal').find('.status0').html("Select file...")
		$('.import-modal').find('.status1').html("")
				
		xgraph.dat1 = { Series:[]};
		xgraph.dat2 = { Series:[]};
		
		var tmp = GetSelectedChartItems();
		for(i=0;i<tmp.length;i++){;
			xgraph.dat1.Series.push({name:'Data '+tmp[i],data:[]});
			xgraph.dat2.Series.push({name:'Data '+tmp[i],data:[]});
		}
		
		xgraph.chart.strip.handle.updateSeries(xgraph.dat1.Series);
		xgraph.chart.image.handle.updateSeries(xgraph.dat2.Series);
		
		RequestJsonEvent(obj); 
	}
	
	function StopXGraph(obj)
	{
		console.log(JSON.stringify(obj));
		
		RequestJsonEvent(obj);
		//clearInterval(handle_for_update);
	}
	
	function RequestJsonEvent(obj)
	{
		var cmd_str =  JSON.stringify(obj);
		var xhp = new XMLHttpRequest();  
		xhp.onreadystatechange = function() {  
		if (this.readyState == 4 && this.status == 200) {	
			console.log("RequestJsonEvent -> "+this.responseText);
			var obj = JSON.parse(this.responseText);
			if(obj.id==0x0A01){ 
				_noti(0, "Set 'Start Chart'.");
				if(!_('btnStart').disabled) _('btnStart').disabled = true;
			}else if(obj.id==0x0A02){ 
				_noti(0, "Set 'Stop Chart'.");
				if(!_('btnStop').disabled) _('btnStop').disabled = true;
			}
		}};
		xhp.open("GET", "../assets/php/requestjson.php?req="+cmd_str, true);
		xhp.send();
		
	}
	
	function CheckDT()
	{
		var d = _('inpDT').value;
		
		if(d<10) _('inpDT').value=10; 
		else if(d>100) _('inpDT').value=100; 
	}
	
	function getDT(){
		var d = new Date();
		 return d.getFullYear()+(d.getMonth()<9?"0":"")+(d.getMonth()+1)+(d.getDate()<10?"0":"")+d.getDate()+'-'+ (d.getHours()<10?"0":"")+d.getHours()+ (d.getMinutes()<10?"0":"")+d.getMinutes()+ (d.getSeconds()<10?"0":"")+d.getSeconds()+" "
	}
	
	function downloadObjectAsJson(exportObj) {
		
		var val = GetSelectedChartItems();
		
		if(val.length < 1) 
		{
			alert("Not selected point, Start the dump again.")
			return;
		}else if(exportObj.length == 0) {
			alert("No data to dump. Start the dump again.")
			return;
		}else if(exportObj.length < 100) {
			alert("Too little data to dump, Start the dump again.")
			return;
		}
		
		var points =""
		for(i=0;i<val.length;i++){ points+=(val[i]+"-")}
		var filename = getDT() + "xgdump s"+exportObj.length+" p"+points;
		
		var obj = { com: 'KNS Inc.',
					content: 'xGraph',
					version: xgraph.GetVersion(),
					model: ant_info.model,
					model_option: ant_info.model_option,
					date:getDT(),
					point:val, 
					sample:exportObj.length, 
					data:exportObj}
		
		console.log("*XGraph Dump Start ------------------------ ")
		console.log(graph_listflag)
		console.log(filename)
		console.log(obj)
		var exportName = filename
	
		if (navigator.msSaveBlob) { // IE10+
			var blob = new Blob([JSON.stringify(obj)], {type : 'application/json'});
			return navigator.msSaveBlob(blob, exportName + ".json");
		}
		var dataStr = "data:application/json;charset=utf-8," + encodeURIComponent(JSON.stringify(obj));
		var downloadAnchorNode = document.createElement('a');
		downloadAnchorNode.setAttribute("href", dataStr);
		downloadAnchorNode.setAttribute("download", exportName + ".json");
		downloadAnchorNode.innerText = exportName;
		document.body.appendChild(downloadAnchorNode); // required for firefox
		downloadAnchorNode.click();
		downloadAnchorNode.remove();
	}
	
	function ResetImageChart(){
		UpdateImageChart(tmpImage)
	}


//-----------------------------------------------------------------------------------------------------------
//xGraph
	var xgraph = {
		/* protocol for helian
			$CMD,TAG0,TAG1,TAG2,TAG3,.......,CMD_ID*CRC+CR+LF
		*/
		GetVersion: function(){  return this.patch[0].v.toFixed(3); },
		GetVersionDT: function(){  return this.patch[0].d; },
		ShowPatch: function (){
			if(document.getElementById('patch').innerHTML!=""){ document.getElementById('patch').innerHTML=""; return; }
			var txt = "";
			txt += "<ul>";
			for(i=0;i<this.patch.length;i++){
				txt += "<li>"+'<div style="float:left;">['+this.patch[i].v.toFixed(3) + ']</div>'+'<div style="padding-left:60px;">'+this.patch[i].c+'</div>'+"</li>";
			}
			document.getElementById('patch').innerHTML = txt;
		},
		patch:[ 
			{v:0.251,	c:'Applied the System GUI.', d:"20210503"},
			{v:0.251,	c:'Added exceptions for the export function.', d:"20210223"},
			{v:0.250,	c:'Added the export function.', d:"20210223"},
			{v:0.241,	c:'Changed chart layout.'},
			{v:0.240,	c:'Fixed chart processing.'},
			{v:0.212,	c:'Changed control UI.'},
			{v:0.212,	c:'Changed serise name of chart.'},
			{v:0.211,	c:'Refactoring(data list UI).'},
			{v:0.210,	c:'Changed data list UI .'},
			{v:0.209,	c:'Applied exception for starting.'},
			{v:0.207,	c:'Changed UI.'},
			{v:0.201,	c:'Applied double click event at block of chart.'},
			{v:0.200,	c:'Chagned layout of data list.'},
			{v:0.162,	c:'Fixed data processing error.'},
			{v:0.160,	c:'Fixed start and stop function.'},
			{v:0.152,	c:'Fixed error (data name)'},
			{v:0.150,	c:'Linked data name to charts.'},
			{v:0.140,	c:'Applied UX.'},
			{v:0.133,	c:'Added control function in web to PCU.'},
			{v:0.130,	c:'Added selected chart types.'},
			{v:0.114,	c:'Added zoom fuction for image chart.'},
			{v:0.112,	c:'Added export button for image chart.'},
			{v:0.111,	c:'Added reset button for image chart.'},
			{v:0.110,	c:'Added chart data list'},
			{v:0.100,	c:'Data processing for chart'},
			{v:0.060,	c:'Added radio style button for sample number.'},
			{v:0.057,	c:'Added image chart.'},
			{v:0.055,	c:'Added strip chart.'},
			{v:0.052,	c:'Data processing - 2'},
			{v:0.05,	c:'Data processing'},
			{v:0.02,	c:'Base'}, 
			{v:0.01,	c:'New project'} 
			],
		chart:{ 
			strip: {handle:null, id:'chart-strip', name:"", series:[]},
			image: {handle:null, id:'chart-image', name:"", series:[]}
		},
		dat1:{ Series:[{name:"?",data:[]}, {name:"?",data:[]}, {name:"?",data:[]}]},
		dat2:{ Series:[{name:"?",data:[]}, {name:"?",data:[]}, {name:"?",data:[]}]},
		UpdateChart: function(){
		
			//console.log("UpdateChart");
		
			$.ajax({
				type: "POST",
				async: false,
				url:        "/feed/xgraph.json",
				dataType:   "json", 
				success:    function(data){
				
					arrStrip = [];
					//check index
					if(old_idx>data[data.length-1].Index){
						old_idx=-1;
						//arrGraph = [];
						Strip=[];
						Image=[];
						for(i;i<ChartData.Series.length;i++)
						{
							ChartData.Series[i].data = [];
						}
					}
					
					if(old_idx<data[data.length-1].Index){
						//Strip 
						for(i=0;i<data.length;i++){
							if(old_idx<data[i].Index){
								//0
								arrStrip.push(data[i]);
								//1
								//arrGraph.push(data[i]);
								//if(arrGraph.length>1000) arrGraph.shift();
							}
						}
						old_idx = data[data.length-1].Index;
					} 
					
					//if(arrStrip.length>0) ProcStrip(arrStrip);
					ProcStrip(arrStrip);
					
					//console.log("Test - StartDraw - 2");
					
				}
			});
		},
		DrawStripChart: function(){
			var lables = [,];			
			var c =  this.chart.strip;
			var options = {
			    chart: {
					id: 'chart-strip',
					type: 'line',
					height: 500,
					background: '#FFFFFF',
					toolbar: {
					  show: false
						},
					animations:{
						dynamicAnimation: {
							enabled: false
						}
					}
			    },title: {
					text: c.name,
					align: 'left'
				},
				colors: ['#0066FF', '#CC3366', '#FF9933', '#009966', '#CCFF33', '#CC33FF'],
				dataLabels: {
					enabled: false,
				},
			  dataLabels: {
				enabled: false
			  },
			  fill: {
				opacity: 1,
				type: 'solid'
			  },
			  series: xgraph.dat1.Series, 
			  tooltip: {
				enabled: false
			  }, 
			  stroke: {
				curve: 'smooth',
				width: 2,      
			  },
			  labels: lables
			}
			
			c.handle = new ApexCharts(
			  document.querySelector('#'+c.id),
			  options
			);
			
			c.handle.render();
		},
		DrawImageChart: function(){	
			var lables = [,];
			for(var i=0;i<2000;i++) lables[i] = i;
			var c =  this.chart.image;
			var options = {
			    chart: {
					id: 'chart-image',
					type: 'line',
					height: 500,
					background: '#FFFFFF',
					toolbar: {
					  show: false
						},
					zoom: {
					  enabled: true,
					  type: 'x',  
					  autoScaleYaxis: false,  
					  zoomedArea: {
						fill: {
						  color: '#90CAF9',
						  opacity: 0.4
						},
						stroke: {
						  color: '#0D47A1',
						  opacity: 0.4,
						  width: 1
						}
					  }
				   },
					toolbar: {
					  show: true
					}
			    },title: {
					text: c.name,
					align: 'left'
				},
				colors: ['#0066FF', '#CC3366', '#FF9933', '#009966', '#CCFF33', '#CC33FF'],
				dataLabels: {
					enabled: false,
				},
			  dataLabels: {
				enabled: false
			  },
			  fill: {
				opacity: 1,
				type: 'solid'
			  },
			  series: xgraph.dat2.Series,
			  stroke: {
				curve: 'smooth',
				width: 2,      
			  },

			  labels: lables
			}
			
			c.handle = new ApexCharts(
			  document.querySelector('#'+c.id),
			  options
			);
			
			c.handle.render();
		}
	};

//-----------------------------------------------------------------------------------------------------------
//Antenna information.
var ant_info = null;

function SendEventForDemo(id,e,vArr){
	if(e>0){
		
		req="async_e"+id;
		req+=_event(e);
		for(var i=0;i<vArr.length;i++) req+=_append(vArr[i]);
		
		req += ","+guid()+","; //Exception for IE.(IE11)
		
		var xhp = new XMLHttpRequest();  
		xhp.responseText = "";
		xhp.addEventListener("error", transferFailed);
		xhp.onreadystatechange = function() {  
		if (this.readyState == 4 && this.status == 200) {
		
			ProcRecv(this.responseText);	
			if(!_start_flag)_start_flag=true;
		}};
		xhp.open("GET", "../assets/php/request.php?req="+req, true);
		xhp.send();
	}
}

function transferFailed(e){}

function ProcRecv(res){
	
	var par=res.split('?');
	
	if(par.length>1&&par[0]=="resp10*1")
	{
		var evs=par[0].split('*');
		var pas=par[1].split(',');
		
		ant_info = { model:pas[65], model_option:'0x'+(parseInt(pas[79]).toString(16)).toUpperCase() }
		
		console.log(ant_info)
	}else{
		SendEventForDemo(10,1,[,]);
	}
}